=== debian/changelog ===
libsfml (2.4.1+dfsg-3) unstable; urgency=medium

  * Apply upstream patch to fix TransientContext deadlocks. (Closes: #855404)

 -- James Cowgill <jcowgill@debian.org>  Mon, 20 Feb 2017 20:11:38 +0000

libsfml (2.4.1+dfsg-2) unstable; urgency=medium

  * Fix segfaults triggered by sf::Window::setIcon. (Closes: #849750)
  * Use debhelper compat 10.

 -- James Cowgill <jcowgill@debian.org>  Fri, 30 Dec 2016 19:02:05 +0000

libsfml (2.4.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Upload 2.4.1 to unstable.

  * debian/control:
    - Mark libsfml-doc as multi-arch foreign.
  * debian/patches:
    - Drop 07_abi.patch - equivalent applied upstream.

 -- James Cowgill <jcowgill@debian.org>  Thu, 03 Nov 2016 21:25:22 +0000

libsfml (2.4.1~git15.b61c2f8+dfsg-1) experimental; urgency=medium

  * New upstream pre-release.
    - Reverts window implementation to X11 from XCB. (Closes: #839104)

  * debian/control:
    - Update dependencies.
    - Ensure graphics 2.4 is not used with window 2.4.1.
  * debian/patches:
    - Refresh patches.
    - Drop 07_config-kfreebsd.patch - applied upstream.
    - Add 07_abi.patch to maintain SFML 2.4 ABI.
  * debian/rules:
    - Bump libsfml-window2.4 shlibs dependency.
  * debian/tests:
    - Fix autopkgtests on Ubuntu by depending on make in the cmake test.

 -- James Cowgill <jcowgill@debian.org>  Thu, 27 Oct 2016 21:34:07 +0100
