=== debian/control ===
Source: libsfml
Section: libs
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Christoph Egger <christoph@debian.org>,
 James Cowgill <jcowgill@debian.org>
Build-Depends: debhelper (>= 10),
 cmake (>= 2.8.9),
 doxygen,
 g++ (>= 6),
 libflac-dev,
 libfreetype6-dev,
 libgl1-mesa-dev,
 libjpeg-dev,
 libopenal-dev,
 libudev-dev [linux-any],
 libusbhid-dev [kfreebsd-any],
 libvorbis-dev,
 libx11-dev,
 libxrandr-dev,
Standards-Version: 3.9.8
Homepage: http://www.sfml-dev.org/
Vcs-Git: https://anonscm.debian.org/git/pkg-games/libsfml.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/libsfml.git
Testsuite: autopkgtest

Package: libsfml-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
 libgl1-mesa-dev | libgl-dev,
 libsfml-audio2.4 (= ${binary:Version}),
 libsfml-graphics2.4 (= ${binary:Version}),
 libsfml-network2.4 (= ${binary:Version}),
 libsfml-system2.4 (= ${binary:Version}),
 libsfml-window2.4 (= ${binary:Version})
Suggests: libsfml-doc
Description: Simple and Fast Multimedia Library - Development Files
 SFML is a modern multimedia library offering a wide range of subsystems
 useful to produce a multimedia app. It offers OpenGL integration for
 Hardware accelerated Graphics, Windowing and Input support, Audio and
 Network facilities and supports GNU/Linux, MS Windows and Mac OS X.
 .
 This package includes header files for all SFML libraries.

Package: libsfml-audio2.4
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Simple and Fast Multimedia Library - Audio part
 SFML is a modern multimedia library offering a wide range of subsystems
 useful to produce a multimedia app. It offers OpenGL integration for
 Hardware accelerated Graphics, Windowing and Input support, Audio and
 Network facilities and supports GNU/Linux, MS Windows and Mac OS X.
 .
 The Audio library is used to play sound and music in games. It is able to
 load OGG/Vorbis files.

Package: libsfml-graphics2.4
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Simple and Fast Multimedia Library - Graphics part
 SFML is a modern multimedia library offering a wide range of subsystems
 useful to produce a multimedia app. It offers OpenGL integration for
 Hardware accelerated Graphics, Windowing and Input support, Audio and
 Network facilities and supports GNU/Linux, MS Windows and Mac OS X.
 .
 The Graphics library contains all the OpenGL and drawing code. It needs the
 Window library for Window creation.

Package: libsfml-network2.4
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Simple and Fast Multimedia Library - Network part
 SFML is a modern multimedia library offering a wide range of subsystems
 useful to produce a multimedia app. It offers OpenGL integration for
 Hardware accelerated Graphics, Windowing and Input support, Audio and
 Network facilities and supports GNU/Linux, MS Windows and Mac OS X.
 .
 The Network Library brings basic networking support as needed by games.

Package: libsfml-system2.4
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Simple and Fast Multimedia Library - System part
 SFML is a modern multimedia library offering a wide range of subsystems
 useful to produce a multimedia app. It offers OpenGL integration for
 Hardware accelerated Graphics, Windowing and Input support, Audio and
 Network facilities and supports GNU/Linux, MS Windows and Mac OS X.
 .
 The system library brings useful system utilities like multithreading and
 UNICODE handling.

Package: libsfml-window2.4
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libsfml-graphics2.4 (<< 2.4.1~)
Description: Simple and Fast Multimedia Library - Window part
 SFML is a modern multimedia library offering a wide range of subsystems
 useful to produce a multimedia app. It offers OpenGL integration for
 Hardware accelerated Graphics, Windowing and Input support, Audio and
 Network facilities and supports GNU/Linux, MS Windows and Mac OS X.
 .
 The Window library provides basic utilities for creating and managing Windows.

Package: libsfml-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery, ${misc:Depends}
Description: Simple and Fast Multimedia Library - Documentation
 SFML is a modern multimedia library offering a wide range of subsystems
 useful to produce a multimedia app. It offers OpenGL integration for
 Hardware accelerated Graphics, Windowing and Input support, Audio and
 Network facilities and supports GNU/Linux, MS Windows and Mac OS X.
 .
 This package includes the library reference and examples for SFML.
