=== debian/changelog ===
libsfml (2.4.2+dfsg-4) unstable; urgency=medium

  * Rebuild with GCC 7 to fix FTBFS of reverse-dependencies. (Closes: #853729)
    - Build-depend on gcc >= 7.
    - Update shlibs to ensure rdeps pull in the new version.

 -- James Cowgill <jcowgill@debian.org>  Sat, 05 Aug 2017 10:34:04 -0400

libsfml (2.4.2+dfsg-3) unstable; urgency=medium

  * debian/patches/02_hurd.patch:
    - Fix Hurd patch to link in Xrandr again after the XCB conversion was
      reverted in 2.4.1.

 -- James Cowgill <jcowgill@debian.org>  Thu, 13 Jul 2017 12:15:38 +0100

libsfml (2.4.2+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

  * debian/control:
    - Bump standards to 4.0.0 (no changes required).

 -- James Cowgill <jcowgill@debian.org>  Sun, 18 Jun 2017 22:22:24 +0100

libsfml (2.4.2+dfsg-1) experimental; urgency=medium

  * New upstream release.

  * debian/copyright:
    - Update copyright dates to 2017.
  * debian/patches:
    - Drop 07_fix-crashing-in-sf-Window-setIcon.patch - applied upstream.

 -- James Cowgill <jcowgill@debian.org>  Fri, 10 Feb 2017 23:49:10 +0000
