=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 Build-Depends: debhelper (>= 10),
  cmake (>= 2.8.9),
  doxygen,
- g++ (>= 6),
+ g++ (>= 4:7),
  libflac-dev,
  libfreetype6-dev,
  libgl1-mesa-dev,
@@ -19,7 +19,7 @@
  libvorbis-dev,
  libx11-dev,
  libxrandr-dev,
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: http://www.sfml-dev.org/
 Vcs-Git: https://anonscm.debian.org/git/pkg-games/libsfml.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/libsfml.git
