=== debian/rules ===
--- 
+++ 
@@ -18,4 +18,6 @@
 override_dh_makeshlibs:
 	# For sf::GlResource::TransitentContextLock added in 2.4.1
 	dh_makeshlibs -plibsfml-window2.4 -V'libsfml-window2.4 (>= 2.4.1~)'
+	# For new symbols when compiled with GCC 7 (this version b-depends on GCC 7)
+	dh_makeshlibs -plibsfml-system2.4 -V'libsfml-system2.4 (>= 2.4.2+dfsg-4~)'
 	dh_makeshlibs --remaining-packages
